﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MementoDesignPattern
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        EmployeeClass objEmployee = new EmployeeClass
        {
            FirstName = "Yogesh",
            LastName = "Mehla",
            Address = "1298 Sector 11",
            Orignal = new EmployeeClassClone
            {
                FirstName = "Yogesh",
                LastName = "Mehla",
                Address = "1298 Sector 11"
            }
        };
        private void Form1_Load(object sender, EventArgs e)
        {
            DisplayDetails();
        }

        private void DisplayDetails()
        {
            txtFirstName.Text = objEmployee.FirstName;
            txtLastName.Text = objEmployee.LastName;
            txtAddress.Text = objEmployee.Address;
        }

        private void btnUpdate_Click(object sender, EventArgs e)
        {
            
            objEmployee.FirstName = txtFirstName.Text;
            objEmployee.LastName = txtLastName.Text;
            objEmployee.Address = txtAddress.Text;
            if (objEmployee.IsModified())
            {
                objEmployee.Orignal.FirstName = objEmployee.FirstName;
                objEmployee.Orignal.LastName = objEmployee.LastName;
                objEmployee.Orignal.Address = objEmployee.Address;
            }
        }

        private void btnIsModified_Click(object sender, EventArgs e)
        {
            objEmployee.FirstName = txtFirstName.Text;
            objEmployee.LastName = txtLastName.Text;
            objEmployee.Address = txtAddress.Text;
            if (objEmployee.IsModified())
            {
                MessageBox.Show("Values modified");
            }
            else {
                MessageBox.Show("Values not modified");
            }
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            objEmployee.Revert();
            DisplayDetails();
        }
    }
}
