﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MementoDesignPattern
{
    public interface EmployeeInt
    {
        string FirstName { get; set; }
        string LastName { get; set; }
        string Address { get; set; }
    }
   public class EmployeeClass :EmployeeInt
    {
        private string firstName;
        public string FirstName
        {
            get
            {
                return firstName;
            }
            set
            {
                firstName = value;
            }
        }
        private string lastName;
        public string LastName
        {
            get
            {
                return lastName;
            }
            set
            {
                lastName = value;
            }
        }
        private string address;
        public string Address
        {
            get
            {
                return address;
            }
            set
            {
                address = value;
            }
        }
        private EmployeeClassClone orignal = new EmployeeClassClone();
        public EmployeeClassClone Orignal
        {
            get {
                return orignal;
            }
            set
            {
                orignal = value;
            }
        }
        public void Revert()
        {
            this.FirstName = Orignal.FirstName;
            this.LastName = Orignal.LastName;
            this.Address = Orignal.Address;
        }
        public Boolean IsModified()
        {
        return !(this.FirstName.Equals(Orignal.FirstName) && this.LastName.Equals(Orignal.LastName) && this.Address.Equals(Orignal.Address));
        }
    }
   public class EmployeeClassClone : EmployeeInt
   {
       private string firstName;
       public string FirstName
       {
           get
           {
               return firstName;
           }
           set
           {
               firstName = value;
           }
       }
       private string lastName;
       public string LastName
       {
           get
           {
               return lastName;
           }
           set
           {
               lastName = value;
           }
       }
       private string address;
       public string Address
       {
           get
           {
               return address;
           }
           set
           {
               address = value;
           }
       }
   }
}
